{ A form to view and edit data. Currently there are two types of data shown in
  the form, state variables and process variables. The state variables form
  allows the user to view and edit the state variables. The process variable
  form is used for viewing only. The user can not edit the process variables
  directly. To change a process value it is necessary to modify the parameters
  in the parameter form. The process values shown in this form are automatically
  updated when the process values in the parameter form are updated.
Al }
unit state;
     
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,stypes, StdCtrls, ExtCtrls;

type
  TDataForm = class(TForm)
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    BtnOK: TButton;
    BtnCancel: TButton;
    DlgPrint: TPrintDialog;
    BtPrint: TButton;
    procedure BtnOKClick(Sender: TObject);
    procedure BtPrintClick(Sender: TObject);
    procedure ShowStates;
    procedure UpdateStates;
    procedure ShowProcess;
    procedure UpdateProcess;
    procedure ClearGrid;
    procedure BtnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataForm : TDataForm;
  DataShowing : TDataType;

implementation

uses fileio, frontend, params;

{$R *.DFM}

// Set up the form to show state variables then show the data
procedure tDataForm.ShowStates;
var
 i:integer;
 s:string[30];
begin
 Caption := 'State Variables';    // Form Caption
 DataShowing := dtState;
 StringGrid1.DefaultColWidth := 190 ;  // StringGrid Properties for state variables
 StringGrid1.ColWidths[0] := 50;
 StringGrid1.rowcount:=ModelDef.numstate+1;
 StringGrid1.ColCount := 4;
 StringGrid1.FixedRows := 1;
 StringGrid1.FixedCols := 1;
 StringGrid1.cells[1,0]:='State Variable Name';
 StringGrid1.cells[2,0]:='State Variable Value';
 StringGrid1.cells[3,0]:='State Variable Units';
 for i:= 1 to ModelDef.numstate do  // Write state variables, names, values and
   begin                            // units to grid
      str(i:3,s);
      StringGrid1.cells[0,i] := s;
      StringGrid1.cells[1,i] := stat[i].name;
      str(stat[i].value,s);
      StringGrid1.cells[2,i] := s;
      StringGrid1.Cells[3,i] := stat[i].units;
   end;
 BtnOK.Visible := True;
 BtnOK.Enabled := True;
 BtnCancel.Caption := '&Cancel';
 ShowModal;   // Show the form
end;

// Set up the form to show process variables then show the data
procedure tDataForm.ShowProcess;
begin
 Caption := 'Process Variables';    // Form Caption
 DataShowing := dtProcess;
 StringGrid1.DefaultColWidth := 190 ;  // StringGrid Properties for state variables
 StringGrid1.rowcount:=ModelDef.numprocess+1;
 StringGrid1.ColCount := 3;
 StringGrid1.FixedRows := 1;
 StringGrid1.FixedCols := 0;
 StringGrid1.cells[0,0]:='Process Variable Name';
 StringGrid1.cells[1,0]:='Process Variable Value';
 StringGrid1.cells[2,0]:='Process Variable Units';
 UpdateProcess;
 BtnOK.Visible := False;
 BtnOK.Enabled := False;
 BtnCancel.Caption := '&Close';
 Show;   // Show the form
end;

// Form has been modified, user wants to save changes
procedure TDataForm.BtnOKClick(Sender: TObject);
begin
if DataShowing = dtState{ and StringGrid1Modified }then
 begin
  updatestates;
  MainForm.MIChart.Enabled := false;
  MainForm.MITable.Enabled := false;
  ClearGrid;
 end
else
 Close;
end;

// Clear the grid when the form closes
procedure TDataForm.BtnCancelClick(Sender: TObject);
begin
 ClearGrid;
 if DataShowing = dtProcess then Close;
end;

// Update global array of state variables with the changes made to the string grid
procedure tDataForm.UpdateStates;
var
 i,code:integer;
begin
 for i:=1 to modeldef.numstate do
   begin   // Copy value in grid to the global state array
     val(DataForm.stringgrid1.cells[2,i],stat[i].value,code);
   end;
 needtosave := true;   // State variables have been changed, parameter file
                       // needs to be saved
end;

{ The procedure updates the process variable values shown in the Dataform.}
procedure tDataForm.UpdateProcess;
var
 i:integer;
 s:string;
begin
 FmParameter.CalculateProcesses;
 for i:= 1 to ModelDef.numprocess do  // Write process variables, names, values and
   begin                            // units to grid
      StringGrid1.cells[0,i] := proc[i].name;
      str(proc[i].value,s);
      StringGrid1.cells[1,i] := s;
      StringGrid1.Cells[2,i] := proc[i].units;
   end;
end;

// Clear the StringGrid so that new data can be written to it
procedure tDataForm.ClearGrid;
var
 i,j : integer;
begin    // Set grid cells to empty strings
 for i := 0 to StringGrid1.RowCount - 1 do
   for j := 0 to StringGrid1.ColCount - 1 do
    StringGrid1.Cells[j,i] := '' ;
 StringGrid1.ColCount := 3;   // Reset column and row count
 StringGrid1.RowCount := 3;
// StringGrid1Modified := False;
end;

// Print out the state variables.
{ This procedure is currently not enabled because it will only print the visible
  state variables. Needs to be fixed to print them all. }
procedure TDataForm.BtPrintClick(Sender: TObject);
begin
with DlgPrint do
   if execute then
     Print;
end;

end.
